
/* --- C ---
************************************************************************
*
*	Filename    : diainfo.i
*	Description : info dialog functions
*	Part of     : XMPLAY - X11-directory-browser for XMPEG
*
*	Version     : 1.0
*	Date        : Sun Feb  6 13:34:10 MET 1994
*	Language    : C
*	For machine : INTERACTIVE Unix, Sun OS, SCO, AU/X, Solaris, Linux
*	Compile as  : see Makefile
*
*	Author      : Frank Gadegast, Juergen Meyer, Metin Cetinkaya
*	Contact     : phade@cs.tu-berlin.de, jm@cs..., brain@cs...
*
************************************************************************
*/

static int fspecial;
char *fpath, *fname, *ftype, *fmode, *flink, *fown, *ftime, *fsize;

void CreateInfW (special, path, name, type, mode, link, own, time, size)
int special;
char *path, *name, *type, *mode, *link, *own, *time, *size;
{
	XSetForeground (theDisp, theGC, infofg);
	XSetBackground (theDisp, theGC, infobg);
	maketitle ("Info");
	infW = XCreateSimpleWindow (theDisp, dirW,
		(dirWIDE-infoWIDE-2*bwidth)/2, (dirHIGH-infoHIGH-2*bwidth)/2,
		infoWIDE, infoHIGH, bwidth, infofg, infobg);
	if (!infW) FatalError ("can't create info window");
	XSelectInput (theDisp, infW, ExposureMask | ButtonPressMask);

	fspecial = special;
	fpath = path;
	fname = name;
	ftype = type;
	fmode = mode;
	flink = link;
	fown = own;
	ftime = time;
	fsize = size;

	BTCreate (&sbut [S_SOK], infW, infoWIDE-85, infoHIGH-35,
		BUTTW, BUTTH, "Ok", infofg, pl, hicol, locol);
	BTSetStyle (&sbut [S_SOK], 1);
	XMapRaised (theDisp, infW);
}

extern int mpeg_info ();

void RedrawInfW ()
{
	MPEGINFO mpeginfo;
	char *infpath;
	char *infname;
	int n;
	char tmp [MAXPATHLEN];

	XSetBackground (theDisp, theGC, infobg);
	XSetForeground (theDisp, theGC, pl);
	XFillRectangle (theDisp, infW, theGC, 0, 0, infoWIDE, 20);
	XSetForeground (theDisp, theGC, infofg);
	SetBold ();
	XDrawString (theDisp, infW, theGC, (infoWIDE-StringWidth (title))/2, 
		15, title, strlen (title));
	XDrawLine (theDisp, infW, theGC, 0, 20, infoWIDE, 20);

	XDrawString (theDisp, infW, theGC, 20, 40, "Path:  ", 7);
	XDrawString (theDisp, infW, theGC, 20, 55, "Name:  ", 7);

	XDrawString (theDisp, infW, theGC, 20, 80, "Width:  ", 7);
	XDrawString (theDisp, infW, theGC, 150, 80, "Height: ", 7);
	XDrawString (theDisp, infW, theGC, 20, 95, "Rate:   ", 7);
	XDrawString (theDisp, infW, theGC, 150, 95, "Stream: ", 7);

	XDrawString (theDisp, infW, theGC, 20, 120, "Type:  ", 7);
	XDrawString (theDisp, infW, theGC, 20, 135, "Mode:  ", 7);
	XDrawString (theDisp, infW, theGC, 20, 150, "Link:  ", 7);
	XDrawString (theDisp, infW, theGC, 20, 165, "Owner: ", 7);
	XDrawString (theDisp, infW, theGC, 20, 180, "Time:  ", 7);
	if (!fspecial)
		XDrawString (theDisp, infW, theGC, 20, 195, "Size:  ", 7);

	SetNormal ();
	n = StringWidth ("Name:  ");
	infpath = ShortCutPath (fpath, infoWIDE-35-n);
	XDrawString (theDisp, infW, theGC, 30+n, 40, infpath, strlen (infpath));
	infname = ShortCutName (fname, infoWIDE-30-n);
	XDrawString (theDisp, infW, theGC, 30+n, 55, infname, strlen (infname));

#ifndef XMPEG
	strcpy (tmp, path);
	strcat (tmp, filename);
#else
	strcpy (tmp, filename);
#endif
	mpeg_info (&mpeginfo, tmp);
	sprintf (tmp, "%d", mpeginfo.v_size);
	XDrawString (theDisp, infW, theGC, 30+n, 80, tmp, strlen (tmp));
	sprintf (tmp, "%d", mpeginfo.h_size);
	XDrawString (theDisp, infW, theGC, 160+n, 80, tmp, strlen (tmp));
	sprintf (tmp, "%d", mpeginfo.picture_rate);
	XDrawString (theDisp, infW, theGC, 30+n, 95, tmp, strlen (tmp));
	if (mpeginfo.XING)
		XDrawString (theDisp, infW, theGC, 160+n, 95, "XING", 4);
	else
		XDrawString (theDisp, infW, theGC, 160+n, 95, "IPB", 3);

	XDrawString (theDisp, infW, theGC, 30+n, 120, ftype, strlen (ftype));
	XDrawString (theDisp, infW, theGC, 30+n, 135, fmode, strlen (fmode));
	XDrawString (theDisp, infW, theGC, 30+n, 150, flink, strlen (flink));
	XDrawString (theDisp, infW, theGC, 30+n, 165, fown, strlen (fown));
	XDrawString (theDisp, infW, theGC, 30+n, 180, ftime, strlen (ftime));
	if (!fspecial)
		XDrawString (theDisp, infW, theGC, 30+n, 195, fsize, strlen (fsize));

	BTRedraw (&sbut [S_SOK]);
}

int InfoEventLoop ()
{
	return (SimpleEventLoop (infW));
}

